# -*- coding: utf-8 -*-
import os
from PyQt4.QtCore import QThread
from mingus.midi import fluidsynth
from mingus.containers.Bar import Bar

class Fluid(QThread):
    def init(self):
        self.bar = Bar()
        self.loop = False
        self.bpm = 120
        self.setDefaultDriver()
        self.setDefautFont()
    
    def run(self):
        fluidsynth.init(self.font,  self.driver)
        if self.loop == True:
            while self.loop == True:
                fluidsynth.play_Bar(self.bar, 1, self.bpm) 
        else:
            fluidsynth.play_Bar(self.bar, 1, self.bpm) 
            if self.loop == True:
                while self.loop == True:
                    fluidsynth.play_Bar(self.bar, 1, self.bpm) 
            
    def setDefaultDriver(self):
        if os.name == "nt":
            self.driver = "Direct Sound"
        elif os.name == "posix":
            self.driver = "alsa"       
     
    def setDefautFont(self):
        if os.name == "nt":
            self.font = "FluidR3_GM.sf2"
        elif os.name == "posix":
            self.font = "/usr/share/sounds/sf2/FluidR3_GM.sf2"

    def setFont(self, font):
        self.font = str(font.toString())
        
    
    def setDriver(self, driver):
        if str(driver.toString()) == 'default' or '':
            self.setDefaultDriver()
        else:
            self.driver = str(driver.toString())
        #fluidsynth.init(self.font,  self.driver)
    
    def setBar(self,  bar):
        self.bar = bar
        
    def setBpm(self,  bpm):
        self.bpm = bpm
        
    def toggleLoop(self,  loop):
        self.loop = loop
